#ifndef _BRAINS_H
#define _BRAINS_H

#include "megahal.h"
#include "LinkList.h"

struct Brain
{
   Brain()
   {
      IsMute = Log = 0;
      CanLearn = VerbLog = WriteTrn = 1;
      LogFile = TrnFile = NULL;
      ThinkTime = 2000;
      SurpriseAvg = 100.0;
   }
   DICTIONARY *ban,*aux,*grt;
   SWAP *swp;
   DICTIONARY *dict;
   MODEL *Model;
   char FileName[256];
   CLinkedList<char *> Chans;
   CLinkedList<char *> Ignores;
   int IsMute, VerbLog, CanLearn, Log, WriteTrn;
   FILE *LogFile, *TrnFile;
   int ThinkTime;
   float SurpriseAvg;
};

enum IgnCmd { IGN_ADD, IGN_REM, IGN_CLEAR };
void Ignore(Brain *brain, char *list, IgnCmd cmd);
void IgnoreCmd(Brain *brain, char *name, IgnCmd cmd);
int  Ignored(Brain *brain, char *name);
Brain * FindBrain(char *chan);
void AttachBrain(Brain *, char *chan);
void DetachBrain(char *chan);
void Attach(Brain *, char *chan);
void Detach(char *chan);
void SaveBrain(Brain *);
void LoadBrain(char *name);
void UnloadBrain(Brain *brain);
void Process(Brain *, char *str);
void Learn(Brain *);
int  GetResponse(Brain *, char *str);
void SetBrain(Brain *);
Brain * ChooseBrain(bool showall);
int  TrainBrain(Brain *, char *fn);
void ShowBrain(Brain *brain);
void LogBrain(Brain *brain, int log);
void AddLog(Brain *brain, char *ctrl, ...);

#define ALLBRAINS(cmd)                             \
{                                                  \
   Brain *brain = &Default;                        \
   int i,len;                                      \
                                                   \
   cmd;                                            \
                                                   \
   len = Brains.NumNodes();                        \
   for(i=0;i<len;i++)                              \
   {                                               \
      brain = Brains.GetDatabyIndex(i);            \
      cmd;                                         \
   }                                               \
}

#endif
