/* By Adam Milazzo - 1999 */

#ifndef _CIRC_H
#define _CIRC_H

#include "cwinsock.h"
#include <windows.h>

class CIRC
{
   private:
      CWinsock    Socks;
      CWSocket    MySock,Ident,IdentConn;
      CRITICAL_SECTION CS;

      char        Nick[256];
      char        IdentStr[32];
      bool        Connected,DoingIdent,Verbose;

      static int  OnRead   (CWSocket *);
      static int  OnConn   (CWSocket *);
      static int  OnClose  (CWSocket *);
      static int  OnErr    (CWSocket *, int);
      static int  OnReq    (CWSocket *);

      char *      GetWord  (char *line, char *word);
      char *      NextWord (char *line);
      void        Parse    (char *line);
      void        Strip    (char *line); // strips colors and stuff

   public:
      CIRC();
      ~CIRC();

      void      (*OnMsg)   (char *src,    char *dest,   char *channel, char *text);
      void      (*OnAction)(char *src,    char *dest,   char *channel, char *text);
      void      (*OnKick)  (char *kicker, char *kicked, char *channel, char *text);
      void      (*OnVerbose)(char *msg);
      void      (*OnConnect)();
      void      (*OnDisconnect)();
      void      (*OnError)(int);

      void        SetVerbose(bool verbose);
      void        SetIdent(char *str);
      char *      GetIdent();

      int         Connect(char *server, int port);
      void        Disconnect(char *reason);
      
      char *      GetNick();
      void        SetNick(char *nick);
      void        SendMessage(char *dest, char *msg);
      void        SendRaw(char *data); // doesnt add newline.. must be null terminated
      void        Join(char *channel);
      void        Part(char *channel);

      CWinsock const & GetSocks()
      { return Socks; }
};

#endif
